diff --git a/src/backend/executor/nodeHash.c b/src/backend/executor/nodeHash.c
index 11db08f..5301bc0 100644
--- a/src/backend/executor/nodeHash.c
+++ b/src/backend/executor/nodeHash.c
@@ -780,45 +1176,412 @@ ExecHashIncreaseNumBuckets(HashJoinTable hashtable)
 	 * Just reallocate the proper number of buckets - we don't need to walk
 	 * through them - we can walk the dense-allocated chunks (just like in
 	 * ExecHashIncreaseNumBatches, but without all the copying into new
-	 * chunks)
+	 * chunks): see ExecHashRebucket, which must be called next.
+	 */
+	if (HashJoinTableIsShared(hashtable))
+	{
+		Size bytes;
+		int i;
+
+		/* Serial phase: only one backend reallocates. */
+		Assert(BarrierPhase(&hashtable->shared->barrier) ==
+			   PHJ_PHASE_RESIZING);
+
+		/* Free the old hash table. */
+		dsa_free(hashtable->area, hashtable->shared->buckets);
+
+		/* Allocate replacement. */
+		bytes = hashtable->nbuckets * sizeof(HashJoinBucketHead);
+		hashtable->shared->buckets = dsa_allocate(hashtable->area, bytes);
+		if (!DsaPointerIsValid(hashtable->shared->buckets))
+			ereport(ERROR,
+					(errcode(ERRCODE_PROGRAM_LIMIT_EXCEEDED),
+					 errmsg("out of memory")));
+
+		/* Initialize empty hash table buckets. */
+		hashtable->buckets =
+			dsa_get_address(hashtable->area,
+							hashtable->shared->buckets);
+		for (i = 0; i < hashtable->nbuckets; ++i)
+			dsa_pointer_atomic_write(&hashtable->buckets[i].shared,
+									 InvalidDsaPointer);
+		hashtable->shared->nbuckets = hashtable->nbuckets;
+
+		/* Update size accounting. */
+		hashtable->shared->size += bytes / 2;
+
+		/* Move all chunks to the rebucket list. */
+		hashtable->shared->chunks_to_rebucket = hashtable->shared->chunks;
+		hashtable->shared->chunks = InvalidDsaPointer;
+	}
+	else
+	{
+		hashtable->buckets =
+			(HashJoinBucketHead *) repalloc(hashtable->buckets,
+											hashtable->nbuckets * sizeof(HashJoinBucketHead));
+
+		memset(hashtable->buckets, 0, hashtable->nbuckets * sizeof(HashJoinBucketHead));
+		/* Move all chunks to the rebucket list. */
+		hashtable->chunks_to_rebucket = hashtable->chunk;
+		hashtable->chunk = NULL;
+	}
+}
+
+/*
+ * Pop a memory chunk from a given list.  Returns a backend-local pointer to
+ * the chunk, or NULL if the list is empty.  Also sets *chunk_out to the
+ * dsa_pointer to the chunk.
+ */
+static HashMemoryChunk
+ExecHashPopChunk(HashJoinTable hashtable,
+				 dsa_pointer *chunk_out,
+				 dsa_pointer *head)
+{
+	HashMemoryChunk chunk;
+
+	Assert(LWLockHeldByMe(&hashtable->shared->chunk_lock));
+
+	if (!DsaPointerIsValid(*head))
+		return NULL;
+
+	*chunk_out = *head;
+	chunk = (HashMemoryChunk)
+		dsa_get_address(hashtable->area, *chunk_out);
+	*head = chunk->next.shared;
+
+	return chunk;
+}
+
+/*
+ * Push a shared memory chunk onto a given list.
+ */
+static void
+ExecHashPushChunk(HashJoinTable hashtable,
+				  HashMemoryChunk chunk,
+				  dsa_pointer chunk_shared,
+				  dsa_pointer *head)
+{
+	Assert(LWLockHeldByMeInMode(&hashtable->shared->chunk_lock, LW_EXCLUSIVE));
+	Assert(chunk == dsa_get_address(hashtable->area, chunk_shared));
+
+	chunk->next.shared = *head;
+	*head = chunk_shared;
+}
+
+/*
+ * ExecHashRebucket
+ *		insert the tuples from hashtable->chunks_to_rebucket into the hashtable
+ */
+void
+ExecHashRebucket(HashJoinTable hashtable)
+{
+	HashMemoryChunk chunk;
+	dsa_pointer chunk_shared;
+	int chunks_processed = 0;
+
+	TRACE_POSTGRESQL_HASH_REBUCKET_START();
+
+	/*
+	 * Scan through all tuples in all chunks in the rebucket list to rebuild
+	 * the hash table.
+	 */
+	if (HashJoinTableIsShared(hashtable))
+	{
+		LWLockAcquire(&hashtable->shared->chunk_lock, LW_EXCLUSIVE);
+		chunk =
+			ExecHashPopChunk(hashtable, &chunk_shared,
+							 &hashtable->shared->chunks_to_rebucket);
+		LWLockRelease(&hashtable->shared->chunk_lock);
+	}
+	else
+		chunk = hashtable->chunks_to_rebucket;
+	while (chunk != NULL)
+	{
+		/* process all tuples stored in this chunk */
+		size_t		idx = 0;
+
+		while (idx < chunk->used)
+		{
+			HashJoinTuple hashTuple = (HashJoinTuple) (chunk->data + idx);
+			dsa_pointer hashTuple_shared = chunk_shared +
+				offsetof(HashMemoryChunkData, data) + idx;
+			int			bucketno;
+			int			batchno;
+
+			ExecHashGetBucketAndBatch(hashtable, hashTuple->hashvalue,
+									  &bucketno, &batchno);
+
+			/* add the tuple to the proper bucket */
+			insert_tuple_into_bucket(hashtable, bucketno, hashTuple,
+									 hashTuple_shared);
+
+			/* advance index past the tuple */
+			idx += MAXALIGN(HJTUPLE_OVERHEAD +
+							HJTUPLE_MINTUPLE(hashTuple)->t_len);
+		}
+		++chunks_processed;
+
+		/* Push chunk back onto the chunk list and move to the next. */
+		if (HashJoinTableIsShared(hashtable))
+		{
+			LWLockAcquire(&hashtable->shared->chunk_lock, LW_EXCLUSIVE);
+			ExecHashPushChunk(hashtable, chunk, chunk_shared,
+							  &hashtable->shared->chunks);
+			chunk =
+				ExecHashPopChunk(hashtable, &chunk_shared,
+								 &hashtable->shared->chunks_to_rebucket);
+			LWLockRelease(&hashtable->shared->chunk_lock);
+		}
+		else
+		{
+			HashMemoryChunk next = chunk->next.private;
+
+			chunk->next.private = hashtable->chunk;
+			hashtable->chunk = chunk;
+			chunk = next;
+		}
+	}
+
+	TRACE_POSTGRESQL_HASH_REBUCKET_DONE(chunks_processed);
+}
+
+static void
+ExecHashTableComputeOptimalBuckets(HashJoinTable hashtable)
+{
+	double		ntuples = (hashtable->totalTuples - hashtable->skewTuples);
+
+	/*
+	 * Guard against integer overflow and alloc size overflow.  The
+	 * MaxAllocSize limitation doesn't really apply for shared hash tables,
+	 * since DSA has no such limit, but for now let's apply the same limit.
 	 */
-	hashtable->buckets =
-		(HashJoinTuple *) repalloc(hashtable->buckets,
-								hashtable->nbuckets * sizeof(HashJoinTuple));
+	while (ntuples > (hashtable->nbuckets_optimal * NTUP_PER_BUCKET) &&
+		   hashtable->nbuckets_optimal <= INT_MAX / 2 &&
+		   hashtable->nbuckets_optimal * 2 <= MaxAllocSize / sizeof(HashJoinBucketHead))
+	{
+		hashtable->nbuckets_optimal *= 2;
+		hashtable->log2_nbuckets_optimal += 1;
+	}
+}
+
+/*
+ * Process the queue of chunks whose tuples need to be redistributed into the
+ * correct batches until it is empty.  Hopefully this will shrink the hash
+ * table, keeping about half of the tuples in memory and sending the rest to a
+ * future batch.
+ */
+static void
+ExecHashShrink(HashJoinTable hashtable)
+{
+	Size size_before_shrink = 0;
+	Size tuples_in_memory = 0;
+	Size tuples_written_out = 0;
+	dsa_pointer chunk_shared;
+	HashMemoryChunk chunk;
+	bool elected_to_decide = false;
+
+	TRACE_POSTGRESQL_HASH_SHRINK_START(hashtable->nbatch);
+
+	if (HashJoinTableIsShared(hashtable))
+	{
+		/*
+		 * Since a newly launched participant could arrive while shrinking is
+		 * already underway, we need to be able to jump to the correct place
+		 * in this function.
+		 */
+		switch (BarrierPhase(&hashtable->shared->shrink_barrier))
+		{
+		case PHJ_SHRINK_PHASE_BEGINNING: /* likely case */
+			break;
+		case PHJ_SHRINK_PHASE_CLEARING:
+			goto clearing;
+		case PHJ_SHRINK_PHASE_WORKING:
+			goto working;
+		case PHJ_SHRINK_PHASE_DECIDING:
+			goto deciding;
+		}
+
+		/*
+		 * We wait until all participants have reached this point.  We need to
+		 * do that because we can't clear the hash table if any partipicant is
+		 * still inserting tuples into it, and we can't modify chunks that any
+		 * participant is still writing into.
+		 */
+		if (BarrierWait(&hashtable->shared->shrink_barrier,
+						WAIT_EVENT_HASH_SHRINKING1))
+		{
+			/* TODO: could also resize hash table here! */
+
+			/* Serial phase: one participant clears the hash table. */
+			memset(hashtable->buckets, 0,
+				   hashtable->nbuckets * sizeof(HashJoinBucketHead));
 
-	memset(hashtable->buckets, 0, hashtable->nbuckets * sizeof(HashJoinTuple));
+			/*
+			 * This participant will also make the decision about whether to
+			 * disable further attempts to shrink.
+			 */
+			size_before_shrink = hashtable->shared->size;
+			elected_to_decide = true;
+		}
+	clearing:
+		/* Wait until hash table is cleared. */
+		BarrierWait(&hashtable->shared->shrink_barrier,
+					WAIT_EVENT_HASH_SHRINKING2);
+
+		Assert(hashtable->shared->nbatch == hashtable->nbatch);
+	}
+	else
+	{
+		/* Clear the hash table. */
+		memset(hashtable->buckets, 0,
+			   sizeof(HashJoinBucketHead) * hashtable->nbuckets);
+	}
+
+	/* Pop first chunk from the shrink queue. */
+	if (HashJoinTableIsShared(hashtable))
+	{
+	working:
+		LWLockAcquire(&hashtable->shared->chunk_lock, LW_EXCLUSIVE);
+		chunk = ExecHashPopChunk(hashtable, &chunk_shared,
+								 &hashtable->shared->chunks_to_shrink);
+		LWLockRelease(&hashtable->shared->chunk_lock);
+	}
+	else
+		chunk = hashtable->chunks_to_shrink;
+
+	/* Process queue until empty. */
+	while (chunk != NULL)
+	{
+		Size idx = 0;
+
+		/* Process all tuples stored in this chunk. */
+		while (idx < chunk->used)
+		{
+			HashJoinTuple hashTuple = (HashJoinTuple) (chunk->data + idx);
+			MinimalTuple tuple = HJTUPLE_MINTUPLE(hashTuple);
+			dsa_pointer	copyTupleShared = InvalidDsaPointer;
+			int			hashTupleSize = (HJTUPLE_OVERHEAD + tuple->t_len);
+			int			bucketno;
+			int			batchno;
+
+			ExecHashGetBucketAndBatch(hashtable, hashTuple->hashvalue,
+									  &bucketno, &batchno);
+
+			if (batchno == hashtable->curbatch)
+			{
+				/* keep tuple in memory - copy it into the new chunk */
+				HashJoinTuple copyTuple;
+
+				if (HashJoinTableIsShared(hashtable))
+					copyTuple = (HashJoinTuple)
+						dense_alloc_shared(hashtable, hashTupleSize,
+										   &copyTupleShared, false, false);
+				else
+					copyTuple = (HashJoinTuple)
+						dense_alloc(hashtable, hashTupleSize);
+				memcpy(copyTuple, hashTuple, hashTupleSize);
+
+				/* and add it back to the appropriate bucket */
+				insert_tuple_into_bucket(hashtable, bucketno, copyTuple,
+										 copyTupleShared);
+				++tuples_in_memory;
+			}
+			else
+			{
+				/* dump it out */
+				Assert(batchno > hashtable->curbatch);
+				ExecHashJoinSaveTuple(hashtable,
+									  HJTUPLE_MINTUPLE(hashTuple),
+									  hashTuple->hashvalue,
+									  batchno,
+									  true);
+
+				hashtable->spaceUsed -= hashTupleSize;
+				++tuples_written_out;
+			}
 
-	/* scan through all tuples in all chunks to rebuild the hash table */
-	for (chunk = hashtable->chunks; chunk != NULL; chunk = chunk->next)
-	{
-		/* process all tuples stored in this chunk */
-		size_t		idx = 0;
+			/* next tuple in this chunk */
+			idx += MAXALIGN(hashTupleSize);
+		}
 
-		while (idx < chunk->used)
+		/* Free chunk and pop next from the shrink queue. */
+		if (HashJoinTableIsShared(hashtable))
 		{
-			HashJoinTuple hashTuple = (HashJoinTuple) (chunk->data + idx);
-			int			bucketno;
-			int			batchno;
+			Size size = chunk->maxlen + offsetof(HashMemoryChunkData, data);
+
+			TRACE_POSTGRESQL_HASH_FREE_CHUNK(size);
+			dsa_free(hashtable->area, chunk_shared);
+
+			LWLockAcquire(&hashtable->shared->chunk_lock, LW_EXCLUSIVE);
+			Assert(hashtable->shared->size > size);
+			hashtable->shared->size -= size;
+			hashtable->shared->tuples_in_memory += tuples_in_memory;
+			hashtable->shared->tuples_written_out += tuples_written_out;
+			tuples_in_memory = 0;
+			tuples_written_out = 0;
+			chunk = ExecHashPopChunk(hashtable, &chunk_shared,
+									 &hashtable->shared->chunks_to_shrink);
+			LWLockRelease(&hashtable->shared->chunk_lock);
+		}
+		else
+		{
+			HashMemoryChunk next = chunk->next.private;
 
-			ExecHashGetBucketAndBatch(hashtable, hashTuple->hashvalue,
-									  &bucketno, &batchno);
+			pfree(chunk);
+			chunk = next;
+		}
+	}
 
-			/* add the tuple to the proper bucket */
-			hashTuple->next = hashtable->buckets[bucketno];
-			hashtable->buckets[bucketno] = hashTuple;
+	/* Decide if shrinking actually reduced memory usage. */
+	if (HashJoinTableIsShared(hashtable))
+	{
+		/*
+		 * Wait until all have finished shrinking chunks.  We need to do that
+		 * because we need the total tuple counts before we can decide whether
+		 * to prevent further attempts at shrinking.
+		 */
+		BarrierWait(&hashtable->shared->shrink_barrier,
+					WAIT_EVENT_HASH_SHRINKING3);
 
-			/* advance index past the tuple */
-			idx += MAXALIGN(HJTUPLE_OVERHEAD +
-							HJTUPLE_MINTUPLE(hashTuple)->t_len);
+		if (elected_to_decide)
+		{
+			/* Serial phase: one participant decides. */
+			if (hashtable->shared->tuples_in_memory == 0 ||
+				hashtable->shared->tuples_written_out == 0)
+			{
+				TRACE_POSTGRESQL_HASH_SHRINK_DISABLED();
+				hashtable->shared->shrinking_enabled = false;
+			}
+
+			TRACE_POSTGRESQL_HASH_SHRINK_STATS(hashtable->shared->tuples_in_memory,
+											   hashtable->shared->tuples_written_out,
+											   size_before_shrink,
+											   hashtable->shared->size);
+		}
+	deciding:
+		/* Wait for above decision to be made. */
+		BarrierWaitSet(&hashtable->shared->shrink_barrier,
+					   PHJ_SHRINK_PHASE_BEGINNING,
+					   WAIT_EVENT_HASH_SHRINKING4);
+	}
+	else
+	{
+		if (tuples_in_memory == 0 || tuples_written_out == 0)
+		{
+			TRACE_POSTGRESQL_HASH_SHRINK_DISABLED();
+			hashtable->growEnabled = false;
 		}
 	}
-}
 
+	TRACE_POSTGRESQL_HASH_SHRINK_DONE();
+}
 
 /*
  * ExecHashTableInsert
  *		insert a tuple into the hash table depending on the hash value
- *		it may just go to a temp file for later batches
+ *		it may just go to a temp file for later batches; if 'preload' is
+ *		then it may be loaded into a chunk but not actually inserted yet;
+ *		return true on success, false if we ran out of work_mem
  *
  * Note: the passed TupleTableSlot may contain a regular, minimal, or virtual
  * tuple; the minimal case in particular is certain to happen while reloading
@@ -826,10 +1589,11 @@ ExecHashIncreaseNumBuckets(HashJoinTable hashtable)
  * case by not forcing the slot contents into minimal form; not clear if it's
  * worth the messiness required.
  */
-void
+bool
 ExecHashTableInsert(HashJoinTable hashtable,
 					TupleTableSlot *slot,
-					uint32 hashvalue)
+					uint32 hashvalue,
+					bool preload)
 {
 	MinimalTuple tuple = ExecFetchSlotMinimalTuple(slot);
 	int			bucketno;
@@ -839,20 +1603,61 @@ ExecHashTableInsert(HashJoinTable hashtable,
 							  &bucketno, &batchno);
 
 	/*
-	 * decide whether to put the tuple in the hash table or a temp file
+	 * decide whether to put the tuple in memory or in a temp file
 	 */
-	if (batchno == hashtable->curbatch)
+	if (batchno == hashtable->curbatch + (preload ? 1 : 0))
 	{
 		/*
 		 * put the tuple in hash table
 		 */
 		HashJoinTuple hashTuple;
 		int			hashTupleSize;
-		double		ntuples = (hashtable->totalTuples - hashtable->skewTuples);
+		dsa_pointer hashTuple_shared = InvalidDsaPointer;
 
 		/* Create the HashJoinTuple */
 		hashTupleSize = HJTUPLE_OVERHEAD + tuple->t_len;
-		hashTuple = (HashJoinTuple) dense_alloc(hashtable, hashTupleSize);
+
+	retry:
+		if (HashJoinTableIsShared(hashtable))
+			hashTuple = (HashJoinTuple)
+				dense_alloc_shared(hashtable, hashTupleSize,
+								   &hashTuple_shared, preload, true);
+		else
+			hashTuple = (HashJoinTuple)
+				dense_alloc(hashtable, hashTupleSize);
+
+		/* Check for failure for allocate. */
+		if (!hashTuple)
+		{
+			if (preload)
+			{
+				/*
+				 * There is no more work_mem into which to preload tuples for
+				 * the next batch, so tell caller to stop doing that.
+				 */
+				Assert(HashJoinTableIsShared(hashtable));
+				return false;
+			}
+			else
+			{
+				/*
+				 * Either dense_alloc_shared has decided that we should
+				 * increase the number of batches or another participant has
+				 * already decided to do that, so we should go and help shrink
+				 * the hash table by sending tuples to future batches.
+				 */
+				Assert(HashJoinTableIsShared(hashtable));
+				ExecHashShrink(hashtable);
+
+				/*
+				 * Try again.  Hopefully memory has been freed up, or we've
+				 * decided to stop respecting work_mem because increasing the
+				 * number of batches isn't helping (large numbers of tuples
+				 * with the same hash value can't be separated).
+				 */
+				goto retry;
+			}
+		}
 
 		hashTuple->hashvalue = hashvalue;
 		memcpy(HJTUPLE_MINTUPLE(hashTuple), tuple, tuple->t_len);
@@ -865,33 +1670,32 @@ ExecHashTableInsert(HashJoinTable hashtable,
 		 */
 		HeapTupleHeaderClearMatch(HJTUPLE_MINTUPLE(hashTuple));
 
-		/* Push it onto the front of the bucket's list */
-		hashTuple->next = hashtable->buckets[bucketno];
-		hashtable->buckets[bucketno] = hashTuple;
+		/* Push it onto the front of the bucket's list, unless preloading */
+		if (!preload)
+			insert_tuple_into_bucket(hashtable, bucketno, hashTuple,
+									 hashTuple_shared);
 
 		/*
 		 * Increase the (optimal) number of buckets if we just exceeded the
 		 * NTUP_PER_BUCKET threshold, but only when there's still a single
 		 * batch.
 		 */
-		if (hashtable->nbatch == 1 &&
-			ntuples > (hashtable->nbuckets_optimal * NTUP_PER_BUCKET))
-		{
-			/* Guard against integer overflow and alloc size overflow */
-			if (hashtable->nbuckets_optimal <= INT_MAX / 2 &&
-				hashtable->nbuckets_optimal * 2 <= MaxAllocSize / sizeof(HashJoinTuple))
-			{
-				hashtable->nbuckets_optimal *= 2;
-				hashtable->log2_nbuckets_optimal += 1;
-			}
-		}
+		if (hashtable->nbatch == 1)
+			ExecHashTableComputeOptimalBuckets(hashtable);
+
+		/*
+		 * TODO: Get rid of the following code, and use the same pattern as
+		 * above, namely let dense_alloc count chunk size (it's more
+		 * accurate!) and let it tell you when you need to back off and
+		 * ExecHashShrink?
+		 */
 
 		/* Account for space used, and back off if we've used too much */
 		hashtable->spaceUsed += hashTupleSize;
 		if (hashtable->spaceUsed > hashtable->spacePeak)
 			hashtable->spacePeak = hashtable->spaceUsed;
 		if (hashtable->spaceUsed +
-			hashtable->nbuckets_optimal * sizeof(HashJoinTuple)
+			hashtable->nbuckets_optimal * sizeof(HashJoinBucketHead)
 			> hashtable->spaceAllowed)
 			ExecHashIncreaseNumBatches(hashtable);
 	}
@@ -900,11 +1704,15 @@ ExecHashTableInsert(HashJoinTable hashtable,
 		/*
 		 * put the tuple into a temp file for later batches
 		 */
-		Assert(batchno > hashtable->curbatch);
-		ExecHashJoinSaveTuple(tuple,
+		Assert(batchno > hashtable->curbatch + (preload ? 1 : 0));
+		ExecHashJoinSaveTuple(hashtable,
+							  tuple,
 							  hashvalue,
-							  &hashtable->innerBatchFile[batchno]);
+							  batchno,
+							  true);
 	}
+
+	return true;
 }
 
 /*
@@ -1047,6 +1855,134 @@ ExecHashGetBucketAndBatch(HashJoinTable hashtable,
 }
 
 /*
+ * Update the local hashtable with the current pointers and sizes from
+ * hashtable->parallel_state.
+ */
+void
+ExecHashUpdate(HashJoinTable hashtable)
+{
+	Barrier *barrier;
+
+	if (!HashJoinTableIsShared(hashtable))
+		return;
+
+	barrier = &hashtable->shared->barrier;
+
+	/*
+	 * This should only be called in a phase when the hash table is not being
+	 * mutated (ie resized, swapped etc).
+	 */
+	Assert(!PHJ_PHASE_MUTATING_TABLE(
+		BarrierPhase(&hashtable->shared->barrier)));
+
+	/* The hash table. */
+	hashtable->buckets = (HashJoinBucketHead *)
+		dsa_get_address(hashtable->area, hashtable->shared->buckets);
+	hashtable->nbuckets = hashtable->shared->nbuckets;
+	/* TODO nbatch? */
+	hashtable->log2_nbuckets = my_log2(hashtable->nbuckets);
+
+	hashtable->curbatch = PHJ_PHASE_TO_BATCHNO(BarrierPhase(barrier));
+}
+
+/*
+ * Get the next tuple in the same bucket as 'tuple'.
+ */
+static HashJoinTuple
+next_tuple_in_bucket(HashJoinTable table, HashJoinTuple tuple)
+{
+	if (HashJoinTableIsShared(table))
+		return (HashJoinTuple)
+			dsa_get_address(table->area, tuple->next.shared);
+	else
+		return tuple->next.private;
+}
+
+/*
+ * Get the first tuple in a given skew bucket identified by number.
+ */
+static HashJoinTuple
+first_tuple_in_skew_bucket(HashJoinTable table, int skew_bucket_no)
+{
+	if (HashJoinTableIsShared(table))
+		return (HashJoinTuple)
+			dsa_get_address(table->area,
+							table->skewBucket[skew_bucket_no]->tuples.shared);
+	else
+		return table->skewBucket[skew_bucket_no]->tuples.private;
+}
+
+/*
+ * Get the first tuple in a given bucket identified by number.
+ */
+static HashJoinTuple
+first_tuple_in_bucket(HashJoinTable table, int bucket_no)
+{
+	if (HashJoinTableIsShared(table))
+	{
+		dsa_pointer p =
+			dsa_pointer_atomic_read(&table->buckets[bucket_no].shared);
+		return (HashJoinTuple) dsa_get_address(table->area, p);
+	}
+	else
+		return table->buckets[bucket_no].private;
+}
+
+/*
+ * Insert a tuple at the front of a given bucket identified by number.  For
+ * shared hash joins, tuple_shared must be provided, pointing to the tuple in
+ * the dsa_area backing the table.  For private hash joins, it should be
+ * InvalidDsaPointer.
+ */
+static void
+insert_tuple_into_bucket(HashJoinTable table, int bucket_no,
+						 HashJoinTuple tuple, dsa_pointer tuple_shared)
+{
+	if (HashJoinTableIsShared(table))
+	{
+		Assert(tuple == dsa_get_address(table->area, tuple_shared));
+		for (;;)
+		{
+			tuple->next.shared =
+				dsa_pointer_atomic_read(&table->buckets[bucket_no].shared);
+			if (dsa_pointer_atomic_compare_exchange(&table->buckets[bucket_no].shared,
+													&tuple->next.shared,
+													tuple_shared))
+				break;
+		}
+	}
+	else
+	{
+		tuple->next.private = table->buckets[bucket_no].private;
+		table->buckets[bucket_no].private = tuple;
+	}
+}
+
+/*
+ * Insert a tuple at the front of a given skew bucket identified by number.
+ * For shared hash joins, tuple_shared must be provided, pointing to the tuple
+ * in the dsa_area backing the table.  For private hash joins, it should be
+ * InvalidDsaPointer.
+ */
+static void
+insert_tuple_into_skew_bucket(HashJoinTable table, int skew_bucket_no,
+							  HashJoinTuple tuple,
+							  dsa_pointer tuple_shared)
+{
+	if (HashJoinTableIsShared(table))
+	{
+		tuple->next.shared =
+			table->skewBucket[skew_bucket_no]->tuples.shared;
+		table->skewBucket[skew_bucket_no]->tuples.shared = tuple_shared;
+	}
+	else
+	{
+		tuple->next.private = table->skewBucket[skew_bucket_no]->tuples.private;
+		table->skewBucket[skew_bucket_no]->tuples.private = tuple;
+	}
+}
+
+/*
  * ExecScanHashBucket
  *		scan a hash bucket for matches to the current outer tuple
  *
@@ -1073,11 +2009,12 @@ ExecScanHashBucket(HashJoinState *hjstate,
 	 * otherwise scan the standard hashtable bucket.
 	 */
 	if (hashTuple != NULL)
-		hashTuple = hashTuple->next;
+		hashTuple = next_tuple_in_bucket(hashtable, hashTuple);
 	else if (hjstate->hj_CurSkewBucketNo != INVALID_SKEW_BUCKET_NO)
-		hashTuple = hashtable->skewBucket[hjstate->hj_CurSkewBucketNo]->tuples;
+		hashTuple = first_tuple_in_skew_bucket(hashtable,
+											   hjstate->hj_CurSkewBucketNo);
 	else
-		hashTuple = hashtable->buckets[hjstate->hj_CurBucketNo];
+		hashTuple = first_tuple_in_bucket(hashtable, hjstate->hj_CurBucketNo);
 
 	while (hashTuple != NULL)
 	{
@@ -1101,7 +2038,7 @@ ExecScanHashBucket(HashJoinState *hjstate,
 			}
 		}
 
-		hashTuple = hashTuple->next;
+		hashTuple = next_tuple_in_bucket(hashtable, hashTuple);
 	}
 
 	/*
@@ -1144,6 +2081,81 @@ ExecScanHashTableForUnmatched(HashJoinState *hjstate, ExprContext *econtext)
 	HashJoinTable hashtable = hjstate->hj_HashTable;
 	HashJoinTuple hashTuple = hjstate->hj_CurTuple;
 
+	if (HashJoinTableIsShared(hashtable))
+	{
+		Assert(BarrierPhase(&hashtable->shared->barrier) ==
+			   PHJ_PHASE_UNMATCHED_BATCH(hashtable->curbatch));
+
+		/*
+		 * For the parallel verison, we'll let each participant pull chunks
+		 * from the queue to work on independently.
+		 */
+		for (;;)
+		{
+			/* Do we need a new chunk? */
+			if (hashtable->chunk == NULL)
+			{
+				dsa_pointer chunk_shared;
+
+				/*
+				 * Try to pop a chunk from the unmatched queue, and put it
+				 * back on the main chunks list.
+				 */
+				LWLockAcquire(&hashtable->shared->chunk_lock, LW_EXCLUSIVE);
+				hashtable->chunk =
+					ExecHashPopChunk(hashtable, &chunk_shared,
+									 &hashtable->shared->chunks_unmatched);
+				if (hashtable->chunk != NULL)
+					ExecHashPushChunk(hashtable, hashtable->chunk,
+									  chunk_shared,
+									  &hashtable->shared->chunks);
+				LWLockRelease(&hashtable->shared->chunk_lock);
+
+				/* If no more chunks in the queue: we're done. */
+				if (hashtable->chunk == NULL)
+					return false;
+
+				hashtable->chunk_unmatched_pos = 0;
+			}
+
+			/* Does the current chunk have any more tuples? */
+			if (hashtable->chunk_unmatched_pos >= hashtable->chunk->used)
+			{
+				/* Try a new chunk. */
+				hashtable->chunk = NULL;
+				continue;
+			}
+			hashTuple = (HashJoinTuple)
+				hashtable->chunk->data + hashtable->chunk_unmatched_pos;
+
+			/* Move to the next tuple in this chunk. */
+			hashtable->chunk_unmatched_pos +=
+				HJTUPLE_OVERHEAD + HJTUPLE_MINTUPLE(hashTuple)->t_len;
+
+			/* Is it unmatched? */
+			if (!HeapTupleHeaderHasMatch(HJTUPLE_MINTUPLE(hashTuple)))
+			{
+				TupleTableSlot *inntuple;
+
+				/* insert hashtable's tuple into exec slot */
+				inntuple = ExecStoreMinimalTuple(HJTUPLE_MINTUPLE(hashTuple),
+												 hjstate->hj_HashTupleSlot,
+												 false);		/* do not pfree */
+				econtext->ecxt_innertuple = inntuple;
+
+				/*
+				 * Reset temp memory each time; although this function doesn't
+				 * do any qual eval, the caller will, so let's keep it
+				 * parallel to ExecScanHashBucket.
+				 */
+				ResetExprContext(econtext);
+
+				hjstate->hj_CurTuple = hashTuple;
+				return true;
+			}
+		}
+	}
+
 	for (;;)
 	{
 		/*
@@ -1152,21 +2164,21 @@ ExecScanHashTableForUnmatched(HashJoinState *hjstate, ExprContext *econtext)
 		 * bucket.
 		 */
 		if (hashTuple != NULL)
-			hashTuple = hashTuple->next;
-		else if (hjstate->hj_CurBucketNo < hashtable->nbuckets)
+			hashTuple = next_tuple_in_bucket(hashtable, hashTuple);
 		{
-			hashTuple = hashtable->buckets[hjstate->hj_CurBucketNo];
-			hjstate->hj_CurBucketNo++;
-		}
-		else if (hjstate->hj_CurSkewBucketNo < hashtable->nSkewBuckets)
-		{
-			int			j = hashtable->skewBucketNums[hjstate->hj_CurSkewBucketNo];
+			if (hjstate->hj_CurBucketNo < hashtable->nbuckets)
+				hashTuple = first_tuple_in_bucket(hashtable,
+												  hjstate->hj_CurBucketNo++);
+			else if (hjstate->hj_CurSkewBucketNo < hashtable->nSkewBuckets)
+			{
+				int			j = hashtable->skewBucketNums[hjstate->hj_CurSkewBucketNo];
 
-			hashTuple = hashtable->skewBucket[j]->tuples;
-			hjstate->hj_CurSkewBucketNo++;
+				hashTuple = first_tuple_in_skew_bucket(hashtable, j);
+				hjstate->hj_CurSkewBucketNo++;
+			}
+			else
+				break;				/* finished all buckets */
 		}
-		else
-			break;				/* finished all buckets */
 
 		while (hashTuple != NULL)
 		{
@@ -1191,7 +2203,7 @@ ExecScanHashTableForUnmatched(HashJoinState *hjstate, ExprContext *econtext)
 				return true;
 			}
 
-			hashTuple = hashTuple->next;
+			hashTuple = next_tuple_in_bucket(hashtable, hashTuple);
 		}
 	}
 
@@ -1212,6 +2224,59 @@ ExecHashTableReset(HashJoinTable hashtable)
 	MemoryContext oldcxt;
 	int			nbuckets = hashtable->nbuckets;
 
+	if (HashJoinTableIsShared(hashtable))
+	{
+		/* Wait for all workers to finish accessing the hash table. */
+		Assert(PHJ_PHASE_TO_SUBPHASE(BarrierPhase(&hashtable->shared->barrier)) ==
+			   PHJ_SUBPHASE_UNMATCHED);
+		if (BarrierWait(&hashtable->shared->barrier, WAIT_EVENT_HASH_UNMATCHED))
+		{
+			/* Serial phase: set up hash table for new batch. */
+			int i;
+
+			Assert(PHJ_PHASE_TO_SUBPHASE(BarrierPhase(&hashtable->shared->barrier)) ==
+				   PHJ_SUBPHASE_PROMOTING);
+
+			/* Clear the hash table. */
+			for (i = 0; i < nbuckets; ++i)
+				dsa_pointer_atomic_write(&hashtable->buckets[i].shared,
+										 InvalidDsaPointer);
+
+			/* Free all the chunks. */
+			/* TODO: Put them on a freelist instead?  Better than making one backend free them all! */
+			while (DsaPointerIsValid(hashtable->shared->chunks))
+			{
+				HashMemoryChunk chunk = (HashMemoryChunk)
+					dsa_get_address(hashtable->area, hashtable->shared->chunks);
+				dsa_pointer next = chunk->next.shared;
+
+				dsa_free(hashtable->area, hashtable->shared->chunks);
+				hashtable->shared->chunks = next;
+			}
+
+			/* Any preloaded chunks for the next batch need to be bucketed. */
+			hashtable->shared->chunks_to_rebucket =
+				hashtable->shared->chunks_preloaded;
+			hashtable->shared->chunks_preloaded = InvalidDsaPointer;
+
+			/* Update the hash table size: it now has the preloaded chunks. */
+			hashtable->shared->size =
+				(hashtable->nbuckets * sizeof(HashJoinBucketHead)) +
+				hashtable->shared->size_preloaded;
+			hashtable->shared->size_preloaded = 0;
+		}
+		/* Wait again, so that all workers now have the new table. */
+		BarrierWait(&hashtable->shared->barrier, WAIT_EVENT_HASH_PROMOTING);
+		Assert(PHJ_PHASE_TO_SUBPHASE(BarrierPhase(&hashtable->shared->barrier)) ==
+			   PHJ_SUBPHASE_LOADING);
+		ExecHashUpdate(hashtable);
+
+		/* Forget the current chunks. */
+		hashtable->chunk = NULL;
+		hashtable->chunk_preload = NULL;
+		return;
+	}
+
 	/*
 	 * Release all the hash buckets and tuples acquired in the prior pass, and
 	 * reinitialize the context for a new pass.
@@ -1220,15 +2285,15 @@ ExecHashTableReset(HashJoinTable hashtable)
 	oldcxt = MemoryContextSwitchTo(hashtable->batchCxt);
 
 	/* Reallocate and reinitialize the hash bucket headers. */
-	hashtable->buckets = (HashJoinTuple *)
-		palloc0(nbuckets * sizeof(HashJoinTuple));
+	hashtable->buckets = (HashJoinBucketHead *)
+		palloc0(nbuckets * sizeof(HashJoinBucketHead));
 
 	hashtable->spaceUsed = 0;
 
 	MemoryContextSwitchTo(oldcxt);
 
 	/* Forget the chunks (the memory was freed by the context reset above). */
-	hashtable->chunks = NULL;
+	hashtable->chunk = NULL;
 }
 
 /*
@@ -1241,10 +2306,14 @@ ExecHashTableResetMatchFlags(HashJoinTable hashtable)
 	HashJoinTuple tuple;
 	int			i;
 
+	/* TODO: share this work out? */
+
 	/* Reset all flags in the main table ... */
 	for (i = 0; i < hashtable->nbuckets; i++)
 	{
-		for (tuple = hashtable->buckets[i]; tuple != NULL; tuple = tuple->next)
+		for (tuple = first_tuple_in_bucket(hashtable, i);
+			 tuple != NULL;
+			 tuple = next_tuple_in_bucket(hashtable, tuple))
 			HeapTupleHeaderClearMatch(HJTUPLE_MINTUPLE(tuple));
 	}
 
@@ -1252,9 +2321,10 @@ ExecHashTableResetMatchFlags(HashJoinTable hashtable)
 	for (i = 0; i < hashtable->nSkewBuckets; i++)
 	{
 		int			j = hashtable->skewBucketNums[i];
-		HashSkewBucket *skewBucket = hashtable->skewBucket[j];
 
-		for (tuple = skewBucket->tuples; tuple != NULL; tuple = tuple->next)
+		for (tuple = first_tuple_in_skew_bucket(hashtable, j);
+			 tuple != NULL;
+			 tuple = next_tuple_in_bucket(hashtable, tuple))
 			HeapTupleHeaderClearMatch(HJTUPLE_MINTUPLE(tuple));
 	}
 }
@@ -1414,11 +2484,11 @@ ExecHashBuildSkewHash(HashJoinTable hashtable, Hash *node, int mcvsToUse)
 				continue;
 
 			/* Okay, create a new skew bucket for this hashvalue. */
-			hashtable->skewBucket[bucket] = (HashSkewBucket *)
+			hashtable->skewBucket[bucket] = (HashSkewBucket *) /* TODO */
 				MemoryContextAlloc(hashtable->batchCxt,
 								   sizeof(HashSkewBucket));
 			hashtable->skewBucket[bucket]->hashvalue = hashvalue;
-			hashtable->skewBucket[bucket]->tuples = NULL;
+			hashtable->skewBucket[bucket]->tuples.private = NULL;
 			hashtable->skewBucketNums[hashtable->nSkewBuckets] = bucket;
 			hashtable->nSkewBuckets++;
 			hashtable->spaceUsed += SKEW_BUCKET_OVERHEAD;
